#!/bin/sh
#
# Portions copyright 2002, 2003 Richard Laager.
# Copyright (c) 1996, 1997, 1998, 1999, Marc Horowitz.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#      This product includes software developed by Marc Horowitz.
# 4. The name of the author may not be used to endorse or promote
#    products derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY MARC HOROWITZ ``AS IS'' AND ANY EXPRESS
# OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED.  IN NO EVENT SHALL MARC HOROWITZ BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# $Id: pks-queue-run.sh.in,v 1.2 2003/09/30 21:33:05 rlaager Exp $
#

conf="$1"

case "x${conf}" in
	x)
		echo "usage: $0 conf_file" 1>&2
		exit 1
		;;
esac

if test ! -r "${conf}" ; then 
	echo "conf_file ${conf} is not readable" 1>&2
	exit 1
fi

dir="`'/usr/bin/awk' '/mail_dir/ { print $2 }' < \"${conf}\"`"
socket="`'/usr/bin/awk' '/socket_name/ { print $2 }' < \"${conf}\"`"
bindir="`'/usr/bin/awk' '/pks_bin_dir/ { print $2 }' < \"${conf}\"`"

delay="${2}"

if test "x${delay}" = "x" ; then
	delay=3
fi

while "/usr/bin/true" ; do 
	for file in "${dir}"/pks-mail.*; do
		# Handle all readable files.
		if test -r "${file}" ; then
			"${bindir}/pksdctl" "${socket}" "mail ${file}"
		fi

		# Sleep to avoid swamping the server.
		sleep "${delay}"
	done

	# Sleep to avoid swamping the CPU or disks.
	sleep "${delay}"
done

